# Generated by the protocol buffer compiler.  DO NOT EDIT!
# Source: google/devtools/artifactregistry/v1beta2/service.proto for package 'Google.Cloud.ArtifactRegistry.V1beta2'
# Original file comments:
# Copyright 2020 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

require 'grpc'
require 'google/devtools/artifactregistry/v1beta2/service_pb'

module Google
  module Cloud
    module ArtifactRegistry
      module V1beta2
        module ArtifactRegistry
          # The Artifact Registry API service.
          #
          # Artifact Registry is an artifact management system for storing artifacts
          # from different package management systems.
          #
          # The resources managed by this API are:
          #
          # * Repositories, which group packages and their data.
          # * Packages, which group versions and their tags.
          # * Versions, which are specific forms of a package.
          # * Tags, which represent alternative names for versions.
          # * Files, which contain content and are optionally associated with a Package
          #   or Version.
          class Service

            include ::GRPC::GenericService

            self.marshal_class_method = :encode
            self.unmarshal_class_method = :decode
            self.service_name = 'google.devtools.artifactregistry.v1beta2.ArtifactRegistry'

            # Lists repositories.
            rpc :ListRepositories, ::Google::Cloud::ArtifactRegistry::V1beta2::ListRepositoriesRequest, ::Google::Cloud::ArtifactRegistry::V1beta2::ListRepositoriesResponse
            # Gets a repository.
            rpc :GetRepository, ::Google::Cloud::ArtifactRegistry::V1beta2::GetRepositoryRequest, ::Google::Cloud::ArtifactRegistry::V1beta2::Repository
            # Creates a repository. The returned Operation will finish once the
            # repository has been created. Its response will be the created Repository.
            rpc :CreateRepository, ::Google::Cloud::ArtifactRegistry::V1beta2::CreateRepositoryRequest, ::Google::Longrunning::Operation
            # Updates a repository.
            rpc :UpdateRepository, ::Google::Cloud::ArtifactRegistry::V1beta2::UpdateRepositoryRequest, ::Google::Cloud::ArtifactRegistry::V1beta2::Repository
            # Deletes a repository and all of its contents. The returned Operation will
            # finish once the repository has been deleted. It will not have any Operation
            # metadata and will return a google.protobuf.Empty response.
            rpc :DeleteRepository, ::Google::Cloud::ArtifactRegistry::V1beta2::DeleteRepositoryRequest, ::Google::Longrunning::Operation
            # Lists packages.
            rpc :ListPackages, ::Google::Cloud::ArtifactRegistry::V1beta2::ListPackagesRequest, ::Google::Cloud::ArtifactRegistry::V1beta2::ListPackagesResponse
            # Gets a package.
            rpc :GetPackage, ::Google::Cloud::ArtifactRegistry::V1beta2::GetPackageRequest, ::Google::Cloud::ArtifactRegistry::V1beta2::Package
            # Deletes a package and all of its versions and tags. The returned operation
            # will complete once the package has been deleted.
            rpc :DeletePackage, ::Google::Cloud::ArtifactRegistry::V1beta2::DeletePackageRequest, ::Google::Longrunning::Operation
            # Lists versions.
            rpc :ListVersions, ::Google::Cloud::ArtifactRegistry::V1beta2::ListVersionsRequest, ::Google::Cloud::ArtifactRegistry::V1beta2::ListVersionsResponse
            # Gets a version
            rpc :GetVersion, ::Google::Cloud::ArtifactRegistry::V1beta2::GetVersionRequest, ::Google::Cloud::ArtifactRegistry::V1beta2::Version
            # Deletes a version and all of its content. The returned operation will
            # complete once the version has been deleted.
            rpc :DeleteVersion, ::Google::Cloud::ArtifactRegistry::V1beta2::DeleteVersionRequest, ::Google::Longrunning::Operation
            # Lists files.
            rpc :ListFiles, ::Google::Cloud::ArtifactRegistry::V1beta2::ListFilesRequest, ::Google::Cloud::ArtifactRegistry::V1beta2::ListFilesResponse
            # Gets a file.
            rpc :GetFile, ::Google::Cloud::ArtifactRegistry::V1beta2::GetFileRequest, ::Google::Cloud::ArtifactRegistry::V1beta2::File
            # Lists tags.
            rpc :ListTags, ::Google::Cloud::ArtifactRegistry::V1beta2::ListTagsRequest, ::Google::Cloud::ArtifactRegistry::V1beta2::ListTagsResponse
            # Gets a tag.
            rpc :GetTag, ::Google::Cloud::ArtifactRegistry::V1beta2::GetTagRequest, ::Google::Cloud::ArtifactRegistry::V1beta2::Tag
            # Creates a tag.
            rpc :CreateTag, ::Google::Cloud::ArtifactRegistry::V1beta2::CreateTagRequest, ::Google::Cloud::ArtifactRegistry::V1beta2::Tag
            # Updates a tag.
            rpc :UpdateTag, ::Google::Cloud::ArtifactRegistry::V1beta2::UpdateTagRequest, ::Google::Cloud::ArtifactRegistry::V1beta2::Tag
            # Deletes a tag.
            rpc :DeleteTag, ::Google::Cloud::ArtifactRegistry::V1beta2::DeleteTagRequest, ::Google::Protobuf::Empty
            # Updates the IAM policy for a given resource.
            rpc :SetIamPolicy, ::Google::Iam::V1::SetIamPolicyRequest, ::Google::Iam::V1::Policy
            # Gets the IAM policy for a given resource.
            rpc :GetIamPolicy, ::Google::Iam::V1::GetIamPolicyRequest, ::Google::Iam::V1::Policy
            # Tests if the caller has a list of permissions on a resource.
            rpc :TestIamPermissions, ::Google::Iam::V1::TestIamPermissionsRequest, ::Google::Iam::V1::TestIamPermissionsResponse
          end

          Stub = Service.rpc_stub_class
        end
      end
    end
  end
end
